#include "OGLWidgetFloating2.h"
#include "VisibleForm.h"
#include <qimage.h>



VisibleForm *fwin2_pForm;
char		fwin2_qstr[128];		// String for onscreen text2
void		*qfont2;


void text2(char* string, void *font ) {
    char* p;
    for(p=string;*p;p++) {
        glutBitmapCharacter(font,*p);
    }
}

void showOnScreenText2() {
    double xpos=0.0;
    double ypos=0.0;
    double delta=0.07;
    
    glPushAttrib(GL_CURRENT_BIT | GL_LIGHTING_BIT);
    glDisable(GL_LIGHTING);
    
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    gluOrtho2D(-1.2,1.2,-1.2,1.2);

    glMatrixMode(GL_MODELVIEW);
    glDisable(GL_LIGHTING);

    xpos=-1.0;
    ypos=-1.0;
        
        //glColor3f(0.95f,0.95f,0.95f);
        //sprintf(fwin2_qstr,"Quaternion Rings");
        //glRasterPos2f(xpos,ypos);
        //text2(fwin2_qstr,GLUT_BITMAP_HELVETICA_12);


	if( fwin2_pForm->mo->objectID == OBJSURFACE ) {
		glColor3f(0.0f,0.0f,0.7f);

		if(fwin2_pForm->swapFrames2) {
			qfont2 = GLUT_BITMAP_HELVETICA_18;
			sprintf(fwin2_qstr,"Geodesic Reference Quaternion Map");
		}
		else if(!fwin2_pForm->swapFrames2) {
			qfont2 = GLUT_BITMAP_HELVETICA_10;
			sprintf(fwin2_qstr,"GR Quaternion Map");
		}

		glRasterPos2f(xpos,ypos);
		text2(fwin2_qstr,qfont2);

		if(fwin2_pForm->swapFrames2) {
			xpos = -1.0;
			glColor3f(1.0f,1.0f,0.2f);
			ypos-=delta;
			switch(fwin2_pForm->mo->qwhichQuatComponent) {
				case SHOWXYZ:
					sprintf(fwin2_qstr,"Components Projected = XYZ");
					break;
				case SHOWWYZ:
					sprintf(fwin2_qstr,"Components Projected = WYZ");
					break;
				case SHOWWXZ:
					sprintf(fwin2_qstr,"Components Projected = WXZ");
					break;
				case SHOWWXY:
					sprintf(fwin2_qstr,"Components Projected = WXY");
					break;
				default:
					break;
			}
			glRasterPos2f(xpos,ypos);
			text2(fwin2_qstr,qfont2);
		}
	}


    glMatrixMode(GL_PROJECTION);   
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glPopAttrib();
}

OGLWidgetFloating2::OGLWidgetFloating2( QWidget* parent, const char* name, QWidget* parentForm)
        : QGLWidget( parent, name)
{
    fwin2_pForm = (VisibleForm*) parentForm;
    init();
}

OGLWidgetFloating2::~OGLWidgetFloating2() 
{
    fwin2_pForm = NULL;
}


//#INITIALIZE
void OGLWidgetFloating2::initializeGL () 
{
        //glClearColor(0.23,0.5,0.65,1.0);
        //glClearColor(0.5f,0.5f,0.5f,1.0f);
    glClearColor(0.23f,0.5f,0.65f,1.0f);

    initLighting();
    m_viewScale = 1.0;
}

void OGLWidgetFloating2::init ( void )
{
	// workspace center
    X=0; Y=0; dX=0; dY=0;
    XC = 0.0; YC = 0.0; ZC = -10.0;
    Cx = 0.0; Cy = 0.0; Cz = 0.0;

        // mouse stuff
    mouseButtons	= 0;
    button			= 0;
    mouseModifiers	= 0;

	// viewport dimensions
    xMin			= -1.0;
    xMax			=  1.0;
    yMin			= -1.0;
    yMax			=  1.0;
    zNear			=  5.0;
    zFar			= 25.0;

    main_height		= this->height();
    main_width		= this->width();

	// moust picking
    litVertex		= -1;
    enable_picking	= 1;
    movingPoint		= FALSE;

}

void OGLWidgetFloating2::initLighting ( void ) 
{
    //static const GLfloat light_model_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light0_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light0_diffuse[]	= {0.9f, 0.9f, 0.9f, 0.9f};  
    //static const GLfloat light0_specular[]	= {1.0f, 1.0f, 1.0f, 1.0f};
    //static const GLfloat light0_shininess[]	= {100.0};
    //static const GLfloat light0_direction[]	= {0.0f, 0.0f, 10.0f, 0.0f};    
    //
    //static const GLfloat light1_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light1_diffuse[]	= {0.9f, 0.0f, 0.0f, 0.9f};  
    //static const GLfloat light1_specular[]	= {1.0f, 1.0f, 1.0f, 1.0f};
    //static const GLfloat light1_shininess[]	= {300.0};
    //static const GLfloat light1_direction[]	= {0.0f, 0.0f, 10.0f, 0.0f};    
    //
    //global_light0[0]=light0_direction[0];
    //global_light0[1]=light0_direction[1];
    //global_light0[2]=light0_direction[2];
    //global_light0[3]=light0_direction[3];
    //
    //    /* Enable depth buffering for hidden surface removal. */
    //glDepthFunc(GL_LEQUAL);
    //glEnable(GL_DEPTH_TEST);
    //
    //    /* Other misc features. */
    //glEnable(GL_LIGHTING);
    //glEnable(GL_NORMALIZE);
    //glShadeModel(GL_SMOOTH);
    //
    //glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
    //glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);    
    //glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light_model_ambient);

    //glLightfv(GL_LIGHT0, GL_DIFFUSE,   light0_diffuse);
    //glLightfv(GL_LIGHT0, GL_POSITION,  light0_direction);
    //glLightfv(GL_LIGHT0, GL_AMBIENT,   light0_ambient);
    //glLightfv(GL_LIGHT0, GL_SPECULAR,  light0_specular);
    //glLightfv(GL_LIGHT0, GL_SHININESS, light0_shininess);
    //glEnable(GL_LIGHT0);     

    //glLightfv(GL_LIGHT1, GL_DIFFUSE,  light1_diffuse);
    //glLightfv(GL_LIGHT1, GL_POSITION, light1_direction);
    //glLightfv(GL_LIGHT1, GL_AMBIENT,  light1_ambient);
    //glLightfv(GL_LIGHT1, GL_SPECULAR, light1_specular);
    //glLightfv(GL_LIGHT1, GL_SHININESS,light1_shininess);
	
    //glEnable(GL_LIGHT0);    
	float s[4];
	float ltc[4],ltp[4];
    ltp[0] = 0.0; ltp[1] = 0.1; ltp[2] = 1.0; ltp[3] = 0.0;
    ltc[0] = 1.0; ltc[1] = 1.0; ltc[2] = 1.0; ltc[3] = 1.0;

    static const GLfloat light_model_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    static const GLfloat light0_ambient[]		= {0.3f, 0.3f, 0.3f, 1.0f};
    static const GLfloat light0_diffuse[]		= {0.9f, 0.9f, 0.9f, 0.9f};  
    static const GLfloat light0_specular[]		= {0.0f, 0.0f, 0.0f, 1.0f};
    static const GLfloat light0_shininess[]		= {100.0};
    static const GLfloat light0_direction[]		= {0.0f, 0.0f, 10.0f, 1.0f};    
    
    global_light0[0]=light0_direction[0];
    global_light0[1]=light0_direction[1];
    global_light0[2]=light0_direction[2];
    global_light0[3]=light0_direction[3];
    
    s[0] = fwin2_pForm->mo->mats[0] * fwin2_pForm->mo->specular;
    s[1] = fwin2_pForm->mo->mats[1] * fwin2_pForm->mo->specular;
    s[2] = fwin2_pForm->mo->mats[2] * fwin2_pForm->mo->specular;
    s[3] = 1.0;

	//printf("s = %f, %f, %f, %f\n",s[0],s[1],s[2],s[3]);
	/* Enable depth buffering for hidden surface removal. */
    glDepthFunc(GL_LEQUAL);
    glEnable(GL_DEPTH_TEST);
    
    /* Other misc features. */
    glEnable(GL_LIGHTING);
    glEnable(GL_NORMALIZE);
    glShadeModel(GL_SMOOTH);
    
    //glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
    //glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);    
    //glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light_model_ambient);

    //glLightfv(GL_LIGHT0, GL_DIFFUSE,   light0_diffuse);
    //glLightfv(GL_LIGHT0, GL_POSITION,  light0_direction);
    //glLightfv(GL_LIGHT0, GL_AMBIENT,   light0_ambient);
    //glLightfv(GL_LIGHT0, GL_SPECULAR,  light0_specular);
    //glLightfv(GL_LIGHT0, GL_SHININESS, light0_shininess);
    //glEnable(GL_LIGHT0);     
	

    s[0] = fwin2_pForm->mo->mats[0] * fwin2_pForm->mo->specular;
    s[1] = fwin2_pForm->mo->mats[1] * fwin2_pForm->mo->specular;
    s[2] = fwin2_pForm->mo->mats[2] * fwin2_pForm->mo->specular;
    s[3] = 1.0;

    glMaterialfv (GL_FRONT_AND_BACK,GL_AMBIENT,fwin2_pForm->mo->mata);
    glMaterialfv (GL_FRONT_AND_BACK,GL_DIFFUSE,fwin2_pForm->mo->matd);
    glMaterialfv (GL_FRONT_AND_BACK,GL_SPECULAR,fwin2_pForm->mo->mats);
    glMaterialf  (GL_FRONT_AND_BACK,GL_SHININESS,fwin2_pForm->mo->shininess);
	//glMaterialf  (GL_FRONT_AND_BACK,GL_SHININESS,1.0);
  
    //glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
    //glEnable     (GL_LIGHTING);
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
    glEnable     (GL_LIGHTING);

    glLightfv    (GL_LIGHT0,GL_POSITION,ltp);
	glLightfv    (GL_LIGHT0,GL_DIFFUSE,ltc);
    glEnable     (GL_LIGHT0);
    glEnable     (GL_NORMALIZE);

}

void OGLWidgetFloating2::resetApp ( void )
{
    m_viewScale = 1.0;

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glFrustum(xMin, xMax, yMin, yMax, zNear, zFar);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glScalef(m_viewScale, m_viewScale, m_viewScale);//@ scale factor
    glTranslatef(XC,YC,ZC);
}

void  OGLWidgetFloating2::resizeGL( int wd, int ht )
{
    int w = wd;
    int h = ht;

    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    glFrustum(xMin, xMax, yMin, yMax, zNear, zFar);
/* Viewing location of camera */
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glTranslatef(XC,YC,ZC);

}

//#EVENT MGMT
void OGLWidgetFloating2::mousePressEvent ( QMouseEvent *e )
{
    QMouseEvent *m = e;
    m = NULL;
    //int x = m->x();
    //int y = m->y();

    //setFocus();
    //
    //X = x;
    //Y =  main_height -y - 1;

    //switch (m->button()){
    //    case  LeftButton:
    //        button = 0x1; /* our Left   bit code */
    //        break;
    //    case MidButton:
    //        button = 0x2; /* our Middle bit code */
    //        break;
    //    case RightButton:
    //        button = 0x4; /* our Right  bit code */
    //        break;
    //    default:
    //        break;
    //}

    //mouseButtons |= button;
    //
    //    //Check if a vertex is lit
    //    // if(button == 0x1){
    //    //     if(litVertex == -1){
    //    ////if(draw_curve==OBJSPLINE) {
    //    ////             //if not, add a new vertex
    //    ////             printf("mouse clicked at (%d,%d)\n",X,Y);
    //    ////             addPoint(X,Y);
    //    ////         }
    //    //     }
    //    //     else{
    //    ////printf("litVertex = %d\n",litVertex);
    //    //         movingPoint = TRUE;
    //    //     }   
    //    // }

    //updateGL();
}

void OGLWidgetFloating2::mouseDoubleClickEvent ( QMouseEvent *e ) 
{
    QMouseEvent *l_e = e;
    l_e = NULL;
    fwin2_pForm->calbak_Swap_Frames_2();
}
void OGLWidgetFloating2::mouseReleaseEvent ( QMouseEvent *e )
{
    QEvent *ev = e;
    ev = NULL;
    
    mouseButtons &= (~(button));
    if(button == 0x1){
        movingPoint = FALSE;
    }
}

void OGLWidgetFloating2::moveTransformedCoordinate(float x, float y)
{
    GLint viewport[4],winHeight;
    GLdouble mvmatrix[16], projmatrix[16];
    GLdouble wx,wy,wz, objx, objy, objz;
   
    glGetDoublev(GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev(GL_PROJECTION_MATRIX, projmatrix);
    glGetIntegerv(GL_VIEWPORT,viewport);
    winHeight = viewport[3];
    
    if(gluProject(xCoord[litVertex], yCoord[litVertex], zCoord[litVertex],
                  mvmatrix, projmatrix, viewport, &wx,&wy,&wz) == GL_FALSE){
        printf("gluProject() didn't work in moveTransformedCooordinates\n");
    }
    
    if(gluUnProject((GLdouble)x, 
                    (GLdouble)y,wz,mvmatrix,projmatrix,viewport, &objx,&objy,&objz) == GL_FALSE){
        printf("gluUnProject() didn't work in moveTransformedCooordinates\n");
    }
    
    xCoord[litVertex]=objx;
    yCoord[litVertex]=objy;
	//buzzform();
}
void OGLWidgetFloating2::mouseMoveEvent ( QMouseEvent *e )
{
    QMouseEvent *m = e;
    int		x = m->x();
    int		y = m->y();
    //double	deltaY	= 0.0;
    //double	deltaX	= 0.0;
    //int		nHatX	= 0;
    //int		nHatY	= 0;
    //double	thetaRad = 0.0;
    //double	thetaDeg = 0.0;
    //double	radius	 = 150.0;
    //double	drSquared= 0.0;
    //float	modelviewMatrix[16];
    
    //double	delta	= 0.0;
    //double	rTheta	= 0.0;
    //double	rangle	= 0.0;

        //@ scaling
    double	y1=0.0;
    double	y2=0.0;
        //@@
    
    xBegin = X;
    yBegin = Y;
    startY = Y;
    X = x;
    Y =  main_height - y - 1;	/* Invert to right-handed system */

        //@ scaling objects
    y1 = (double)yBegin;
    y2 = (double)Y;
        //@@

    xNext = X;
    yNext = Y;

	//// Passive motion callback is simulate here with the
	//// boolean movingPoint
	////if( enable_picking ) {
	////	//mousePickVertex(x,y);
	////	//printf("selected= %d\n",litVertex);
	////}
 //   
 //       //case 0x2:  
 //       //if((m->state() & LeftButton) && (m->state() & ShiftButton)) {
 //       //    
 //       //        if(movingPoint == TRUE && litVertex > -1){
 //       //moveTransformedCoordinate(X,Y);
 //       ////flagPointMoved = 1;
 //       //            //if(mouseModifiers != GLUT_ACTIVE_SHIFT){
 //       //            //    moveTransformedCoordinate(X,Y);
 //       //            //}
 //       //            //else{
 //       //            //    //shift is pressed so move in Z
 //       //            //    deltaY = Y - (int)startY;
 //       //            //    zCoord[litVertex] = zCoord[litVertex] - (float)deltaY/20.0;
 //       //            //    if(zCoord[litVertex] > zNear){
 //       //            //        zCoord[litVertex] = zNear;
 //       //            //    }
 //       //            //    if(zCoord[litVertex] < (zNear - (zFar - zNear))){
 //       //            //        zCoord[litVertex] =(zNear - (zFar - zNear)) ;
 //       //            //    }
 //       //            //}
 //       //        }
 //       //}
 //   
 //       //case 0x2:  /* Left Mouse Button - ROTATE OBJECT */
 //   if(m->state()==LeftButton){

 //       //deltaX = xNext - xBegin;
 //       //deltaY = yNext - yBegin;
 //       //nHatX = (int)-deltaY;
 //       //nHatY = (int)deltaX;
 //       //    //get the amount of rotation
 //       //drSquared = pow(deltaX,2) + pow(deltaY,2);
 //       //thetaRad = acos(radius/(sqrt(pow(radius,2) + drSquared)));
 //       //thetaDeg = (thetaRad * 180) / M_PI;
 //       //    //translate to center
 //       //glGetFloatv(GL_MODELVIEW_MATRIX,modelviewMatrix);
 //       //glMatrixMode(GL_MODELVIEW);
 //       //glLoadIdentity();
 //       //glTranslatef(XC,YC,ZC);
 //       //glTranslatef(Cx, Cy, 0);
 //       //    
 //       //glRotatef(thetaDeg,nHatX,nHatY,0);
 //       //    //tranlsate back
 //       //glTranslatef(-Cx, -Cy, 0);
 //       //glTranslatef(-XC,-YC,-ZC);
 //       //glMultMatrixf(modelviewMatrix);

 //       
 //   }
	//
 //   if((m->state() & LeftButton) && (m->state() & ShiftButton)) {
 //       if(fwin2_pForm->mo->trackingRing != -1) {
 //           delta = 0.1;

 //           rTheta = (y2-y1)/2.0;
	//		
 //           if(rTheta > 0.0)
 //               rTheta = delta;
 //           else if(rTheta < 0.0)
 //               rTheta = -1.0*delta;

 //           rangle = fwin2_pForm->mo->rthetaList[fwin2_pForm->mo->trackingRing] + rTheta;
 //           if(rangle > (4.0*M_PI))
 //               rangle = 4.0*M_PI;
 //           else if(rangle < 0.0)
 //               rangle = 0.0;

 //           fwin2_pForm->mo->rthetaList[fwin2_pForm->mo->trackingRing] = rangle;
 //           fwin2_pForm->notifyOGLWidgets();
 //       }
 //   }

 //       //case 0x4:  /* Right Mouse Button  */
 //       //translating
 //   if( (m->state() & RightButton) && (m->state() & ShiftButton)) {
 //       
 //       glGetFloatv(GL_MODELVIEW_MATRIX,modelviewMatrix);
 //       glMatrixMode(GL_MODELVIEW);
 //       glLoadIdentity();
 //       glTranslatef(((float)xNext-xBegin)/((float)main_width/2.0),
 //                    ((float)yNext-yBegin)/((float)main_height/2.0),0);
 //       glMultMatrixf(modelviewMatrix);

 //       
 //       Cx = Cx + ((float)xNext-xBegin)/((float)main_width/2.0);
 //       Cy = Cy + ((float)yNext-yBegin)/((float)main_height/2.0);
 //   }
 //   else  if((m->state() & RightButton) && !(m->state() & ShiftButton))//scaling
 //   {
 //       m_viewScale *= 1 + (y2 - y1)/((double)main_height*10.0);
 //       if(m_viewScale<0.5)
 //           m_viewScale=0.5;
 //       if(m_viewScale>4.0)
 //           m_viewScale=4.0;
 //   }  

 //   updateGL();
}

void OGLWidgetFloating2::keyPressEvent ( QKeyEvent *e )
{
    QMessageBox mb( "Exiting...",
                    "Really quit?",
                    QMessageBox::NoIcon,
                    QMessageBox::Yes | QMessageBox::Default,
                    QMessageBox::No,QMessageBox::NoButton );

    switch(e->key()) {

        case Key_Space:
            break;

        case Key_H:
            fwin2_pForm->calbak_Help();
            break;

        case Key_A:
            fwin2_pForm->mo->rshowAxes = !fwin2_pForm->mo->rshowAxes;
            break;
            
        case Key_B:
            break;
            
        case Key_C:
            fwin2_pForm->mo->rshowCurve = !fwin2_pForm->mo->rshowCurve;
            fwin2_pForm->mo->rshowEdge  = 0;
            break;
            
        case Key_E:
            if(fwin2_pForm->mo->objectID == OBJBELT) {
                fwin2_pForm->mo->qshowEdge = !fwin2_pForm->mo->qshowEdge;
            }
            else if(fwin2_pForm->mo->objectID == OBJKNOT) {
                fwin2_pForm->mo->rshowEdge = !fwin2_pForm->mo->rshowEdge;
                fwin2_pForm->mo->rshowCurve= 0;
            }
            break;

        case Key_F:
            if(e->state()&&ShiftButton) {
                fwin2_pForm->mo->rshowFrame = !fwin2_pForm->mo->rshowFrame;
            }
            else {
                fwin2_pForm->mo->rshowFace = !fwin2_pForm->mo->rshowFace;
            }
            break;

        case Key_G:
            break;

        case Key_K:
            break;

        case Key_L:
            fwin2_pForm->mo->showLabels = !fwin2_pForm->mo->showLabels;
            fwin2_pForm->notifyOGLWidgets();
            break;

        case Key_M:
            fwin2_pForm->mo->qshowQuatRingsSurfaceMesh = !fwin2_pForm->mo->qshowQuatRingsSurfaceMesh;
            break;

        case Key_N:
            break;

        case Key_P:
            break;

        case Key_Q:
            break;            

        case Key_R:
            if(e->state()&&ShiftButton) {
                fwin2_pForm->mo->qshowQuatRings = !fwin2_pForm->mo->qshowQuatRings;
                fwin2_pForm->mo->qshowQuatRingsSurface = !fwin2_pForm->mo->qshowQuatRingsSurface;
            }
            else	
                this->resetApp();
            break;

        case Key_S:
            break;

        case Key_T:
            break;

        case Key_W:
            fwin2_pForm->mo->qwhichQuatComponent = SHOWXYZ;
            break;

        case Key_X:
            fwin2_pForm->mo->qwhichQuatComponent = SHOWWYZ;
            break;

        case Key_Y:
            fwin2_pForm->mo->qwhichQuatComponent = SHOWWXZ;
            break;

        case Key_Z:
            fwin2_pForm->mo->qwhichQuatComponent = SHOWWXY;
            break;
            
        case Key_1:
            break;

        case Key_2:

            break;

        case (Key_3):
            break;

        case (Key_4):
            break;
            
        case 27 :
        case Key_Escape:
            if(mb.exec() == QMessageBox::Yes)
                fwin2_pForm->exitApp();
            break;
            
        default:
            break;
    }
    fwin2_pForm->stateChange();
    updateGL();
}



//#RENDER
void OGLWidgetFloating2::paintGL ()
{
	int		i				= 0;
	double	factor			= 0.0;
	double	separationFactor= 2.0;
	double	divFactor		= (double)fwin2_pForm->mo->numPoints/separationFactor;
	double	divFactor2		= (double)315/2.0;
	double	offset			= 0.0;
	double	offset_local	= 0.0;
	double	value			= 0.0;
	int		limit			= 0;

	if(fwin2_pForm->mo->flag_curve_closed)
		limit = fwin2_pForm->mo->numPoints-2;
	else
		limit = fwin2_pForm->mo->numPoints-1;


    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
		glTranslatef(-0.05,-0.75,0.0);
		//glutSolidSphere(0.1,16,16);
	//glScalef(1.5,1.5,1.5);
 //   fwin2_pForm->stateChange();

 //   glPushMatrix();
 //   glTranslatef(Cx, Cy, 0);
 //   glScalef(m_viewScale, m_viewScale, m_viewScale);
 //       fwin2_pForm->mo->showGaussMap();
 //   glPopMatrix();	

	//if(fwin2_pForm->mo->showOnScreenHelp)
	//	showOnScreenText2();
	//if(fwin2_pForm->mo->flag_update_track_ring) {
	//	fwin2_pForm->updateForm();
	//	fwin2_pForm->mo->flag_update_track_ring = 0;
	//}
	//printf("\tINDEX = %d, energy = %f\n",fwin_pForm->mo->opt_INDEX, fwin_pForm->mo->mtaENERGY);
	//printf("\tpoint(x) = %f, point(y) = %f\n",((double)fwin_pForm->mo->opt_INDEX)/100.0, (fwin_pForm->mo->mtaENERGY)*factor);
	
	if(fwin2_pForm->swapFrames2) {
	glPushAttrib(GL_ALL_ATTRIB_BITS);
			glLineWidth(0.25f);
			glPointSize(1.0f);
		glDisable(GL_LIGHTING);
		for(i=10;i<400;i+=20) {
			
			//if((i%10==0) ) {
				glColor3f(0.95f,0.95f,0.95f);
				glPushMatrix();
					glTranslatef((((double)i/divFactor2)-1.0), -0.1, 0.0);
					sprintf(fwin2_qstr,"%d",i);
					glRasterPos2f(0.0,0.0);
					text2(fwin2_qstr,GLUT_BITMAP_HELVETICA_10);
				glPopMatrix();
				glPushMatrix();
					//glTranslatef((((double)i)/separationFactor-1.0), 0.0, 0.0);
					//glutSolidSphere(0.02,8,8);
					glBegin(GL_POINTS);
						glVertex3f((((double)i/divFactor2)-1.0), 0.0, 0.0);
					glEnd();
				glPopMatrix();

				glBegin(GL_LINES);
					glVertex3f( (((double)i/divFactor2)-1.0), -1.0, 0.0);
					glVertex3f( (((double)i/divFactor2)-1.0), 1.5, 0.0);
				glEnd();
			
			//}
		}
		for(i=-70;i<220;i+=20) {
			
			//if((i%10==0) ) {
				glColor3f(0.95f,0.95f,0.95f);
				glPushMatrix();
					glTranslatef(-1.2, (((double)i)/divFactor2), 0.0);
					sprintf(fwin2_qstr,"%.2f",(double)i/100.0);
					glRasterPos2f(0.0,0.0);
					text2(fwin2_qstr,GLUT_BITMAP_HELVETICA_10);
				glPopMatrix();
				glColor3f(0.65f,0.65f,0.65f);
				glBegin(GL_LINES);
					glVertex3f( -1.0, (((double)i)/divFactor2), 0.0);
					glVertex3f( 1.55, (((double)i)/divFactor2), 0.0);
				glEnd();
			
			//}
		}	
		if(fwin2_pForm->swapFrames2) {
			glColor3f(0.95f,0.95f,0.95f);
			glPushMatrix();
				glTranslatef(-1.75,1.0,0.0);
				sprintf(fwin2_qstr,"Y-AXIS");
				glRasterPos2f(0.0,0.0);
				text2(fwin2_qstr,GLUT_BITMAP_HELVETICA_12);
			glPopMatrix();
			glPushMatrix();
				glTranslatef(-1.75,0.85,0.0);
				sprintf(fwin2_qstr,"Relative measure");
				glRasterPos2f(0.0,0.0);
				text2(fwin2_qstr,GLUT_BITMAP_HELVETICA_12);
			glPopMatrix();
			glPushMatrix();
				glTranslatef(-1.75,0.0,0.0);
				sprintf(fwin2_qstr,"X-AXIS");
				glRasterPos2f(0.0,0.0);
				text2(fwin2_qstr,GLUT_BITMAP_HELVETICA_12);
			glPopMatrix();
			glPushMatrix();
				glTranslatef(-1.75,-0.2,0.0);
				sprintf(fwin2_qstr,"Index of Curve-Points");
				glRasterPos2f(0.0,0.0);
				text2(fwin2_qstr,GLUT_BITMAP_HELVETICA_12);
			glPopMatrix();
		}
	glPopAttrib();
	}

	glPushAttrib(GL_LIGHTING_BIT);
		glDisable(GL_LIGHTING);
			glLineWidth(2.0f);
			glColor3f(0,0,0.5);
			//X-AXIS
			glBegin(GL_LINES);
				glVertex3f(1.75,0,0);
				glVertex3f(-1,0,0);
			glEnd();
			//Y-AXIS
			glBegin(GL_LINES);
				glVertex3f(-1,-1,0);
				glVertex3f(-1,1.75,0);
			glEnd();
			if(fwin2_pForm->swapFrames2) {
				glPointSize(2.85f);
				glLineWidth(0.75f);
			}
			else {
				glPointSize(0.1f);
				glLineWidth(0.25f);
			}
			
			
			//@ Quat-Quat Inner Dot Product
			if(fwin2_pForm->mo->gshowQdotprod) {
				factor = 1.0;
				offset = 0.33;
				glColor3f(0.65,0,0);
				glBegin(GL_LINE_STRIP);
				for(i=0; i<limit-2; i++) {
						glVertex3f( (((double)i)/(divFactor)-1.0), (fwin2_pForm->mo->list_mtaENERGY_dist[i])*factor+offset, 0.0);
				}
				glEnd();
				glColor3f(0.85,0,0);
				for(i=0; i<limit-2; i++) {
					glBegin(GL_POINTS);
						glVertex3f( (((double)i)/(divFactor)-1.0), (fwin2_pForm->mo->list_mtaENERGY_dist[i])*factor+offset, 0.0);
					glEnd();				
				}
			}

			//@ Turning Angle experienced by 3D-Frames
			if(fwin2_pForm->mo->gshowQdist) {
				if(fwin2_pForm->mo->list_mtaENERGY_angle[2]<0.0001)
					factor = 200.0;
				else if(fwin2_pForm->mo->list_mtaENERGY_angle[2]>0.1)
					factor = 0.5;
				else if(fwin2_pForm->mo->list_mtaENERGY_angle[2]<0.1)
					factor = 0.5;
				else 
					factor = 100.0;

				glColor3f(0,0,.65);
				glBegin(GL_LINE_STRIP);
				for(i=0; i<limit; i++) {
						glVertex3f( (((double)i)/(divFactor)-1.0), (fwin2_pForm->mo->list_mtaENERGY_angle[i])*factor, 0.0);
				}
				glEnd();
				glColor3f(0.0,0,.95);
				for(i=0; i<limit; i++) {
					glBegin(GL_POINTS);
						glVertex3f( (((double)i)/(divFactor)-1.0), (fwin2_pForm->mo->list_mtaENERGY_angle[i])*factor, 0.0);
					glEnd();				
				}
			}

			//@ Tangential Acceleration Experienced by Quaternion-Curve
			if(fwin2_pForm->mo->gshowQtangacc) {
				if(fwin2_pForm->mo->list_mtaENERGY_tacc[2]<0.00001)
					factor = 1.0e5;
				else if(fwin2_pForm->mo->list_mtaENERGY_tacc[2]<0.0001)
					factor = 100.0;
				else if(fwin2_pForm->mo->list_mtaENERGY_tacc[2]<0.1)
					factor = 0.5;
				else if(fwin2_pForm->mo->list_mtaENERGY_tacc[2]>0.1)
					factor = 0.5;
				else 
					factor = 100.0;

				glColor3f(0,.65,0);
				glBegin(GL_LINE_STRIP);
				for(i=0; i<limit; i++) {
					//value = (fwin2_pForm->mo->list_mtaENERGY_tacc[i])/(fwin2_pForm->mo->gmax_curve_qtangacc);
					//offset_local = (fwin2_pForm->mo->gmax_curve_curvature) - (fwin2_pForm->mo->CurvList[i]);
					glVertex3f( (((double)i)/(divFactor)-1.0), (fwin2_pForm->mo->list_mtaENERGY_tacc[i])*factor, 0.0);
					//glVertex3f( (((double)i)/separationFactor-1.0), (value-(offset_local*400.0)+offset)*factor, 0.0);
					//printf("val = %f\n",(value-(offset_local*400.0)+offset)*factor);
				}
				glEnd();
				glColor3f(0.0,.95,0);
				for(i=0; i<limit; i++) {
					glBegin(GL_POINTS);
						////glVertex3f( (((double)i)/separationFactor-1.0), (fwin2_pForm->mo->list_mtaENERGY_tacc[i])*factor, 0.0);
						//value = (fwin2_pForm->mo->list_mtaENERGY_tacc[i])/(fwin2_pForm->mo->gmax_curve_qtangacc);
						//offset_local = (fwin2_pForm->mo->gmax_curve_curvature) - (fwin2_pForm->mo->CurvList[i]);
						glVertex3f( (((double)i)/(divFactor)-1.0), (fwin2_pForm->mo->list_mtaENERGY_tacc[i])*factor, 0.0);
						//glVertex3f( (((double)i)/separationFactor-1.0), (value-(offset_local*400.0)+offset)*factor, 0.0);
					glEnd();				
				}
			}
			
			//@ Curvature of 3D-Curve
			if(fwin2_pForm->mo->gshowCcurvature) {
				factor = 100.0;
				glColor3f(.65,.65,0);
				glBegin(GL_LINE_STRIP);
				for(i=0; i<limit; i++) {
					//value = (fwin2_pForm->mo->CurvList[i])*factor;
					//value = value - 99.0;
					value = (fwin2_pForm->mo->CurvList[i])/(fwin2_pForm->mo->gmax_curve_curvature);
					offset_local = (fwin2_pForm->mo->gmax_curve_curvature) - (fwin2_pForm->mo->CurvList[i]);
					value = (fwin2_pForm->mo->CurvList[i])/(fwin2_pForm->mo->gmax_curve_curvature);
					glVertex3f( (((double)i)/(divFactor)-1.0), value-(offset_local*400.0)+offset, 0.0);
					//printf("[%d] value = %f\n",i,value);
				}
				glEnd();
				glColor3f(.95,.95,0);
				for(i=0; i<limit; i++) {
					//value = (fwin2_pForm->mo->CurvList[i])*factor;
					//value = value - 99.0;
					value = (fwin2_pForm->mo->CurvList[i])/(fwin2_pForm->mo->gmax_curve_curvature);
					offset_local = (fwin2_pForm->mo->gmax_curve_curvature) - (fwin2_pForm->mo->CurvList[i]);
					//printf("[%d] value = %f,offset = %f\n",i,value-(offset_local*400.0)+offset,offset);
					glBegin(GL_POINTS);
						glVertex3f( (((double)i)/(divFactor)-1.0), value-(offset_local*400.0)+offset, 0.0);
					glEnd();				
				}
			}
			//@ Torsion of 3D-Curve
			if(fwin2_pForm->mo->gshowCtorsion) {
				factor = 1.0;
				glColor3f(0,.65,0.65);
				glBegin(GL_LINE_STRIP);
				for(i=0; i<limit; i++) {
					value = (fwin2_pForm->mo->TorsnList[i])*factor;
					//value = value - 99.0;
						glVertex3f( (((double)i)/(divFactor)-1.0), value, 0.0);
				}
				
				glEnd();
				glColor3f(0,.95,.95);
				for(i=0; i<limit; i++) {
					value = (fwin2_pForm->mo->TorsnList[i])*factor;
					//value = value - 99.0;
					glBegin(GL_POINTS);
						glVertex3f( (((double)i)/(divFactor)-1.0), value, 0.0);
					glEnd();				
				}
			}
			//@ Turning-angle of 3D-Curve
			if(1) {
				factor = 0.25;
				glColor3f(0.0,.0,0.0);
				glBegin(GL_LINE_STRIP);
				for(i=0; i<fwin2_pForm->mo->numRingPoints; i++) {
					value = fwin2_pForm->mo->list_ENERGY_turnang[i]*factor;
					//printf("val = %f\n",value);
					//value = (fwin2_pForm->mo->TorsnList[i])*factor;
					//value = value - 99.0;
						glVertex3f( (((double)i)/(divFactor*3)-1.0), value, 0.0);
				}
				
				glEnd();
				glColor3f(0,0,0);
				for(i=0; i<fwin2_pForm->mo->numRingPoints; i++) {
					value = fwin2_pForm->mo->list_ENERGY_turnang[i]*factor;
					//value = (fwin2_pForm->mo->TorsnList[i])*factor;
					//value = value - 99.0;
					if(i==fwin2_pForm->mo->turnang_markIndex)
						glColor3f(1,0,0);
					else
						glColor3f(0,0,0);
					glBegin(GL_POINTS);
						glVertex3f( (((double)i)/(divFactor*3)-1.0), value, 0.0);
					glEnd();				
				}
			}			
	glPopAttrib();
	glPopMatrix();
}

//#UTILITIES
int OGLWidgetFloating2::saveScreenAsBMP( )
{
    static int	counter = 1;
    char		fname[100];

	//# Make GL Context current
    makeCurrent();

	//# Copy from OpenGL screen buffer
    QImage *tempImage = new QImage( grabFrameBuffer() );

    if ( !tempImage ) {
        fprintf(stderr,"Error! Failed to allocate memory for image\n");
        return false;
    }

    
        /* Open the file */
    if(fwin2_pForm->mo->whichFrame == FRENETSERRET)
        sprintf(fname,"./snapshots/quatring_%d_%d_torus_knot_frenet%01d.bmp",fwin2_pForm->mo->m,fwin2_pForm->mo->n,counter);
    else if(fwin2_pForm->mo->whichFrame == PARALLELTRANSPORT)
        sprintf(fname,"./snapshots/quatring_%d_%d_torus_knot_parelltrans%01d.bmp",fwin2_pForm->mo->m,fwin2_pForm->mo->n,counter);

    if ( !tempImage->save( QString(fname), "BMP") ) {
        fprintf(stderr,"Error! Could not save BMP file...\n");
        return false;
    }
    else {
        printf("Saved! Writing out file: %s\n",fname);
        counter++;
    }
	 
	//# Clean memory
    delete tempImage;

    return true;

}



//@ Adding points manually
void OGLWidgetFloating2::addPoint ( int x, int y) 
{
    GLdouble	objx, objy, objz;
    GLint		viewport[4],winHeight;
    GLdouble	mvmatrix[16], projmatrix[16];

        //y=0 is at bottom of screen here
    if(totalPoints < 100){
        glGetDoublev(GL_MODELVIEW_MATRIX, mvmatrix);
        glGetDoublev(GL_PROJECTION_MATRIX, projmatrix);
        glGetIntegerv(GL_VIEWPORT,viewport);
        winHeight = viewport[3];

        if(gluUnProject((GLdouble)x,(GLdouble)y,0.5, mvmatrix,projmatrix,viewport,&objx,&objy,&objz) == GL_FALSE){
            printf("gluUnProject() didn't work in addPoint()\n");
        }
        else{
                //printf("totalPoints = %d, pnt = %f, %f, %f\n",totalPoints,objx, objy, objz);
            xCoord[totalPoints] = objx;
            yCoord[totalPoints] = objy;
            zCoord[totalPoints] = objz;
            totalPoints++;
        }
    }
	////flagPointAdded = 1;
	////buzzform();
}


void OGLWidgetFloating2::processHits(GLint hits, GLuint buffer[])
{
    
    GLuint	*ptr = NULL;
    GLuint	names = 0;

    int i,j;
    
    ptr= (GLuint *) buffer;
    
    if(hits ==0){
        litVertex = -1;
        fwin2_pForm->mo->selected_point = -1;
    }
    
    
    for(i=0; i< hits; i++){
        names = *ptr;
        ptr++;
        ptr++;//don't need z1
        ptr++;//don't need z2
        if(i==0){
            litVertex = *ptr;
        }
        else if(i==1 && zCoord[litVertex] > *ptr){
            litVertex = *ptr;
        }
        for (j = 0; j < (signed)names; j++) {	/*  for each name */
            ptr++;
        }
            //printf("selected= %d\n",litVertex);
        fwin2_pForm->mo->selected_point = litVertex;
    }
}

void OGLWidgetFloating2::mousePickVertex(int x, int y)
{
	
    GLuint selectBuf[BUFSIZE];
    GLint hits;
    GLint viewport[4];

        //get the dimensions of the viewport
    glGetIntegerv(GL_VIEWPORT,viewport);
    
    glSelectBuffer(BUFSIZE,selectBuf);
    (void) glRenderMode(GL_SELECT);
  
    glInitNames();
        //push an initial name onto the stack so we can use LoadName() later
    glPushName(0);
    

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();

        //center the picking region around the mouse location
    gluPickMatrix((GLdouble)x, (GLdouble)(viewport[3]-y),10,10,viewport);
    
    glFrustum(xMin, xMax, yMin, yMax, zNear, zFar);
    
        // WARNING: change to GL_MODELVIEW before drawing in GL_SELECT mode
        // otherwise unpredictable rendering will occur.
    glMatrixMode(GL_MODELVIEW);

        //drawPoints(GL_SELECT);
	//fwin2_pForm->mo->showQuaternionCurve_PickingMode(GL_SELECT);


    glMatrixMode(GL_PROJECTION);
    glPopMatrix();

        // WARNING: change to GL_MODELVIEW before leaving the routine
        // otherwise unpredictable rendering will occur.
    glMatrixMode(GL_MODELVIEW);
    hits=glRenderMode(GL_RENDER);

        //process the hits
    processHits(hits,selectBuf);
    updateGL();
}

void OGLWidgetFloating2::drawPoints(GLenum mode)
{
    int i, size=0;
    
    for(i=0; i<totalPoints; i++){
        glPushAttrib(GL_CURRENT_BIT);
        glDisable(GL_LIGHTING);

        if(i == litVertex){
                //glColor3f(bgcolor[0]-0.2,bgcolor[1]-0.2,bgcolor[2]-0.2);
            size = 27;
        }

        drawPoint(xCoord[i], yCoord[i], zCoord[i], size, i, mode);
        size=6;
        glPopAttrib();
        
    }
    
}


void OGLWidgetFloating2::drawPoint(float x,float y,float z,int size, int name, GLenum mode)
{
        //if(showControlPoints) {
        
    glPointSize(size);
    if(mode == GL_SELECT){
        glLoadName(name);
    }
    glBegin(GL_POINTS);
    glVertex3f(x,y,z);
    glEnd();
    glPointSize(6.0);
        //}
    
}
