#ifndef _OBJ_KNOT_
#define _OBJ_KNOT_

#include "MathObject.h"

void	TEST ( void );
// rendering and admin
void	initializeApplication					( MathObject *mathobjRef );	//
void	initCurve								( void );			//
void	initKnot								( void );			//
void	drawKnottedCurve						( void );			//
void	drawPoints								( GLenum mode );	//
void	drawPoint								( double *point, float size, int name, GLenum mode); //

// computational
void	computeSplineEquation					( void );			//
void	P										( Vertex P0, Vertex P1, Vertex P2, Vertex P3 , Vertex *P, double t, int currentSpline );
void	constructKnot							( void );			//
void	makeTangent								( void );			//
void    makeTangentDerivatives					( void );			//
void	makeCurve_Curvature						( void );			//
void	makeCurve_Torsion						( void );			//
void	computeFrenetSerretFrame				( void );			//
void	computeFrenetSerretFrame_forSingleFrame	( void );			//
void	computeParallelTransportFrame			( void );			//
void	computeGeodesicReferenceFrame			( void );			//
void	makeTangent_forQuatMap					( void );			//
void	makeTangentDerivatives_forQuatMap		( void );			//

void	computeFrenetSerretFrame_forSingleFrame_forQuatMap	( void );
void	computeParallelTransportFrame_forQuatMap( void );			//

void	computeTorus							( void );			//
void	computeSphere							( void );			//
void	computeCatenoid							( void );			//
void	computeEnneper							( void );			//
void	computeGeodesicReferenceFrame_MANIFOLD	( void );			//

// render > curve
void    drawLabels                              ( void );			//
void	drawPalette								( void );			//
void    drawFrames								( void );			//
void	drawFrames_forQuatMap					( void );			//
void    drawQuaternionUnitSphere                ( void );			//
void    drawQuaternionCurve						( void );			//
void    drawQuaternionReflectedCurve            ( void );			//
void	drawQuaternionPoints					( void );			//
void	constructFramedCurve					( double radius );	//
void	renderFramedCurve						( double radius );	//
void	constructFramedCurve_forQuatMap			( double radius );	//
void	renderFramedCurve_forQuatMap			( double radius );	//
void    renderFramedQuaternionCurve             ( double radius );	//
void	renderFramedQuaternionCurve_forFSMap	( void );	//

// render > rings
void	computeQuaternionRings					( void );			//
void	computeQuaternionRingsSurface_normals	( void );			//	
void	drawQuaternionRings						( void );			//
void	drawQuaternionRings_forOpenCurve		( void );			//

void	updateQuaternionRings					( void );			//
void	findQuat_Current						( int i, quaternion *retQuat, double* retAngle );
void	findQuat_Previous						( int i, quaternion *retQuat, double* retAngle );
void	findQuat_Previous2						( int ind, quaternion *prevQuat, double* prevTheta, int SIGN );
void	test_FindQuat							( void );			//
void	test_FindQuat							( double ANGLE );	//

// render > surface
void	renderTorus								( void );			//
void	renderSphereSurface						( void );			//
void	renderSurfaceObject						( void );			//
void	renderGaussMap							( void );			//
void	drawQuaternionCurve_SURFACE				( void );			//

// utility
void    copyQuatList							( void );			//
void	copyQuatList_OPT						( void );			//
void	copyQuatToPointList						( int for_which_frame );
void    copyReflectedQuatToPointList            ( void );			//
void	getQuatComp								( int whichQuatComponent, quaternion* q, double* qvec);	//
void	getSegmentColor							( int i, double *ccolor );								//

// OPTIMIZATION
void	computeProperties						( int index );		//
void	optCalcTurningAngle						( int index );		//
void	optCalcTurningAngle2					( int index );		//
void	optMinTurningAngle						( int index );
void	optCalcPTFrame_TurningAngle				( void );

//PT Methods
void buildQuaternion_forRings ( int index, double theta, quaternion *quatRet );
void optPT_step0 ( void );
void optPT_step ( int index );
void optPT_step2 ( int index ); 
void optPT_step3 ( int index ); 
void optPT_step4 ( int index );//original
void optPT_QuatCurveEnergy 						( void );
void drawFrames_forOptimization					( void );


void	initOPTIM_TurningAngle					( void );			//
void	initOPTIM_STRUCT						( void );			//
void	drawQuaternionCurve_OPT					( void );			//
void	optQuatCurveEnergy						( void );			//
void	optQuatCurveEnergy_CNT					( int MAX );		//
void	optSECANTmethod							( void );			//
void	optSECANTstep							( double currVal, double prevVal, double* nextVal );	//
void	optNAIVEmethod							( void );			//
void	optNAIVEstep							( int index );		//
void	optNRmethod								( void );			//
void	optNRstep								( int index );		//
void	optNR_naive_method						( void );			//
void	optNR_naive_step						( int index );		//
//MTA Method
void	calc_num_SecondOrder_diff_3POINT		( const quaternion *q0, const quaternion *q1, const quaternion *q2, quaternion *q3, double h );
void	calc_TangAcceleration					( quaternion *qDD, quaternion *q, double h, double *retValue );
void	optMTAsetup								( void );			//
void	optMTAmethod							( void );			//
void	optMTAstep								( int index );		//
	

//LOADING MESHVIEW DATA FILES
typedef struct node{
    double v;
    struct node *next;
} node;

typedef struct {
    node *begin;
    node *end;
    int count;
} queue;

//data structs

//subroutines
void    globalVarInit   ( void );
void    load_data		( const char *filename );
int	    loadLINE		( const char *filename, Obj **objret );
int	    loadLINES		( const char *filename, Obj ***objret, int flag );
void    draw_line		( Obj *obj, int flag );
void    draw_lines		( Obj *obj, int flag );
void    copyLineList_toPointList ( int LineIndex );


/////////////////////////////////////////////////////////////////////////////////////////
void	drawFrames_QuatMapEdit					( void );			//
void	drawFrames_FromQuaternionMap			( void );			//
void    drawQuaternionCurve						( double *color );	//
void    drawQuaternionCurve_forPicking			( double *color, GLenum mode ); //
void    drawQuaternionCurve_forRings			( double *color );	//
void	drawQuaternionCurve_FromModifiedQuatMap ( double *color );	//	
void	drawCurve								( void );			//
void	drawCurveShadow							( void );			//
void	drawTangentsDTangents					( void );			//

void	drawQuaternionCurve						( int start, int end, double* color );	//
void    drawRings								( );				//
void    displayKnotQuaternionMap				( void );			//
void	displayQuaternionRings					( void );			//
void	drawTangDTangSpace						( void );			//
void	renderFramedCurve						( double radius );	//
void    renderThickenedCurve					( double radius );	//
void    renderThickenedCurve2					( double radius );	//
void    renderFramedQuaternionCurve				( double radius );	//
void	renderFramedQuaternionCurve2			( double radius );	// 
void	renderFramedQuaternionCurve3			( double radius, double *color, int flag_use_extern_color );//
void	makeFamilyOfQuaternions					( double theta, double *v, quaternion* qf );				//


#endif
