#ifndef _QUATERNION_H_
#define _QUATERNION_H_

#include <math.h>

typedef struct {
        
	double r;
    double i;
    double j;
    double k;
	int	color;
    double  theta;
}quaternion;


/* QUATERNION UTILITIES */
void	quatBuildQuaternion			( double theta, double i, double j, double k, quaternion *q );
void	quatBuildQuaternion			( double theta, double* vector, quaternion *q );
void	quatMakeUnitQuaternion		( quaternion *q, double r, double i, double j, double k );
void	quatGenerate				( quaternion *q, double theta, double *v);
void	quatConjugate				( quaternion *q ); 
double	quatQuatDistance			( quaternion *q1, quaternion *q2 );
double	quatQuatDotProduct			( quaternion *q1, quaternion *q2 );
void	quatQuatProduct				( quaternion *q1, quaternion *q2, quaternion *q3);
void	quatQuatProduct2			( quaternion *q1, quaternion *q2, quaternion *q3);
void	quatToRotationMatrix		( quaternion *q, double *mat );
void	quatToRotationMatrixf		( quaternion *q, float *mat );
void	quatFromRotationMatrix		( double *mat, quaternion *q );
double	qNorm						( quaternion* q );
double	qNorm2						( quaternion q );
void	quatMakeQuaternion			( quaternion *q, double r, double i, double j, double k );
void	quatNormalize				( quaternion *q );
void	quatCopy					( const quaternion *q1, quaternion *q2 );
void	quatPrint					( quaternion *q );
void	ExtractQuaternionFromMat	( double m[16], quaternion *q );
void	ExtractQuaternionFromMat2	( double m[16], quaternion *q );
void	matToQuat					( double m[4][4], quaternion* quat );


#endif
